var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AsyncAction } from "./AsyncAction";
import { wrapError } from "../utils";
export const getSeriesTasksAsyncActionClass = () => class STSuperClass extends AsyncAction {
    execute(dispatch, getState) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = yield this.payload.tasks.reduce((prevTask, nextTask) => prevTask.then((prevResults) => {
                let nextTaskResult = null;
                if (typeof nextTask === 'function') {
                    try {
                        nextTaskResult = nextTask(prevResults, getState);
                        if (nextTaskResult === false) {
                            return prevResults.concat([nextTaskResult]);
                        }
                    }
                    catch (error) {
                        return prevResults.concat([wrapError(error)]);
                    }
                }
                const dispatchResult = dispatch((nextTaskResult === null ? nextTask : nextTaskResult));
                return Promise.resolve(dispatchResult)
                    .then((result) => prevResults.concat([result]))
                    .catch((error) => prevResults.concat([wrapError(error)]));
            }), Promise.resolve([]));
            if (typeof this.payload.onComplete === 'function') {
                const onResolveResult = this.payload.onComplete(results, dispatch, getState);
                if (typeof onResolveResult !== 'undefined') {
                    return onResolveResult;
                }
            }
            return results;
        });
    }
};
